
#include <Servo.h> 

Servo myservo; 
int pos = 10;  // global, can be static (persistent)
int st = +1;   // global, can be static (persistent)

void setup() 
{ 
  Serial.begin(9600);
  myservo.attach(9); 
 } 
 
 
void loop() 
{ 
  if (pos == 10)
 	  st = +1;
  if (pos == 170)
   	st = -1;
 	pos = pos + st;

//  pos = 180 - pos;
  
  myservo.write(pos);
  
  long cm = data();  
  
  Serial.print(pos); Serial.print( " "); Serial.println(cm);
  delay(150);   // a shorter delay might give a system sending data too fast to the serial port, which might cause octave miss some data; no problem with matlab  
}


long data()
{
  const int pingPin = 13;
  long duration;
  pinMode(pingPin, OUTPUT);
  digitalWrite(pingPin, LOW);
  delayMicroseconds(2);
  digitalWrite(pingPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(pingPin, LOW);
  pinMode(pingPin, INPUT);
  duration = pulseIn(pingPin, HIGH);
  // convert the time into a distance
  long cm = microsecondsToCentimeters(duration);  
  if (cm>300)
      cm = 300;
  return cm;
}



long microsecondsToCentimeters(long microseconds)
{
  return microseconds / 29 / 2;
}


